using Avalonia.Controls;
using Avalonia.Interactivity;
using Avalonia.Media;
using System;
using System.Diagnostics.Metrics;
using System.IO;
using static System.Net.Mime.MediaTypeNames;
using System.Text.RegularExpressions;
using System.Collections.Generic;
using System.Linq;



namespace AvaloniaApplication3
{
    public struct Person
    {
        public string Lastname; 
        public string Name; 
        public string Patronymic; 
        public string FM; 
        public string Number; 
        public int Day; 
        public int Month; 
        public int Year;
        public string DayOfWeek;
        public string SlavicGod;
    }
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        public SolidColorBrush color(string FM)
        {
            switch (FM)
            {
                case "Мужской":
                    return new SolidColorBrush(Color.FromArgb(50,0, 0, 255));
                case "Женский":
                    return new SolidColorBrush(Color.FromArgb(50, 200, 0, 0));
                default:
                    return new SolidColorBrush(Color.FromRgb(0, 0, 0));
            }
        }

        private void ShowUsersClick(object sender, RoutedEventArgs e)
        {

            ShowUsers.IsVisible = true;
            WritePanel.IsVisible = false;
            List<Person> listOfPerson = new List<Person>();
            List<Person> OrderedPersons = new List<Person>();
            using (StreamReader sr = new StreamReader("users.csv"))
            {
                string line = "";


                while (!sr.EndOfStream)
                {
                    line = sr.ReadLine();
                    string[] lineArray = line.Split(';');
                    listOfPerson.Add(new Person
                    {
                        Lastname = lineArray[0],
                        Name = lineArray[1],
                        Patronymic = lineArray[2],
                        FM = lineArray[3],
                        Number = lineArray[4],
                        Day = Convert.ToInt32(lineArray[5]),
                        Month = Convert.ToInt32(lineArray[6]),
                        Year = Convert.ToInt32(lineArray[7]),
                        DayOfWeek = lineArray[8],
                        SlavicGod = lineArray[9],
                    });
                    
                }

                OrderedPersons = listOfPerson.OrderBy(x => x.Lastname).ThenBy(y=>y.Name).ToList();


                for(int i=0; i<OrderedPersons.Count; i++)
                {
                    TextBlock tbName = new TextBlock()
                    {
                        Text = OrderedPersons[i].Lastname + " " + OrderedPersons[i].Name
                    };
                    TextBlock tbPatronymic = new TextBlock()
                    {
                        Text = OrderedPersons[i].Patronymic
                    };
                    TextBlock tbFM = new TextBlock()
                    {
                    Text = OrderedPersons[i].FM
                    };
                    TextBlock tbNumber = new TextBlock()
                    {
                        Text = OrderedPersons[i].Number
                    };

                    TextBlock tbDay = new TextBlock()
                    {
                        Text = OrderedPersons[i].Day + "." + OrderedPersons[i].Month+ "." + OrderedPersons[i].Year
                    };

                    TextBlock tbDayOfWeek = new TextBlock()
                    {
                        Text = OrderedPersons[i].DayOfWeek
                    };
                    TextBlock tbSlavicGod = new TextBlock()
                    {
                        Text = OrderedPersons[i].SlavicGod
                    };
                    StackPanel spUser = new StackPanel();
                    spUser.HorizontalAlignment = Avalonia.Layout.HorizontalAlignment.Center;
                    spUser.Children.Add(tbName);
                    spUser.Children.Add(tbPatronymic);
                    spUser.Children.Add(tbFM);
                    spUser.Children.Add(tbNumber);
                    spUser.Children.Add(tbDay);
                    spUser.Children.Add(tbDayOfWeek);
                    spUser.Children.Add(tbSlavicGod);

                    Border border = new Border();
                    border.Background = color(OrderedPersons[i].FM);
                    border.BorderBrush = Brushes.Azure;
                    border.BorderThickness = new Avalonia.Thickness(2);
                    border.CornerRadius = new Avalonia.CornerRadius(50);
                    border.Margin = new Avalonia.Thickness(10);
                    border.Padding = new Avalonia.Thickness(20);

                    border.Child = spUser;

                    ShowUsers.Children.Add(border);
                }
                    
                    

                   
                }
            }
        
    
        private void WriteFile(object sender, RoutedEventArgs e)
        {
            ShowMessageNumber.Text = "";
            ShowMessageName.Text = "";
            ShowMessageLastname.Text = "";
            ShowMessage.Text = "";
            Person person = new Person();
            bool check = true;

            person.Lastname = tbLastname.Text;
            person.Name = tbName.Text;
            int monthInFile = 0;
            int dayInFile = 0;
            int yearInFile = 0;
            person.Patronymic = tbPatronymic.Text;


            if (rbM.IsChecked == true) person.FM = "Мужской";
            if (rbF.IsChecked == true) person.FM = "Женский";

            person.Number = tbNumber.Text;

            person.Day = Convert.ToInt32(tbDay.Text);
            dayInFile = person.Day;
            person.Month = cbMonth.SelectedIndex;
            monthInFile = person.Month;

            person.Year = Convert.ToInt32(tbYear.Text);
            yearInFile = person.Year;



            Regex number = new Regex("^8\\(\\d{3}\\)\\d{3}-\\d{2}-\\d{2}$");
            Regex name = new Regex("^[А-Я]{1}[а-я]{1,}$");
            Regex lastname = new Regex("^[А-Я]{1}[а-я]{2,}$");
            if (!number.IsMatch(person.Number))
            {
                ShowMessageNumber.Text = "Номер введен некоректно";
                check = false;
            }
                if (!name.IsMatch(person.Name))
                {
                    ShowMessageName.Text = "Имя введено некорректно";
                check = false;
            }
                if (!lastname.IsMatch(person.Lastname))
             {
                    ShowMessageLastname.Text = "Фамилия введена некорректно";
                check = false;
            }
            if (check)
            {
                using (StreamWriter sw = new StreamWriter("users.csv", true, System.Text.Encoding.UTF8))
                {
                    DateTime userDate = new DateTime(yearInFile, monthInFile, dayInFile);
                    string dayOfWeek = Convert.ToString(userDate.DayOfWeek);


                    if (monthInFile == 1)
                    {
                        if(dayInFile <= 30)
                        {
                            person.SlavicGod = "Мороз";
                        }
                        else
                        {
                            person.SlavicGod = "Велес";
                        }
                    }
                    else if (monthInFile == 2)
                    {
                        person.SlavicGod = "Велес";
                    }
                    else if (monthInFile == 3)
                    {
                        person.SlavicGod = "Макошь";
                    }
                    else if (monthInFile == 4)
                    {
                        person.SlavicGod = "Жива";
                    }
                    else if (monthInFile == 5)
                    {
                        if (dayInFile <= 14)
                        {
                            person.SlavicGod = "Ярило";
                        }
                        else
                        {
                            person.SlavicGod = "Леля";
                        }
                    }
                    else if (monthInFile == 6)
                    {
                        if (dayInFile <= 2)
                        {
                            person.SlavicGod = "Леля";
                        }
                        else if (dayInFile <= 12 && dayInFile > 2)
                        {
                            person.SlavicGod = "Кострома";
                        }
                        else
                        {
                            person.SlavicGod = "Додола";
                        }
                    }
                    else if (monthInFile == 7)
                    {
                        if (dayInFile <= 6)
                        {
                            person.SlavicGod = "Додола";
                        }
                        else if (dayInFile == 24)
                        {
                            person.SlavicGod = "Иван Купала";
                        }
                        else
                        {
                            person.SlavicGod = "Лада";
                        }
                    }
                    else if (monthInFile == 8)
                    {
                        if (dayInFile <= 28)
                        {
                            person.SlavicGod = "Перун";
                        }
                        else
                        {
                            person.SlavicGod = "Сева";
                        }
                    }
                    else if (monthInFile == 9)
                    {
                        if (dayInFile <= 13)
                        {
                            person.SlavicGod = "Сева";
                        }
                        else if (dayInFile <= 27 && dayInFile > 13)
                        {
                            person.SlavicGod = "Рожаница";
                        }
                        else
                        {
                            person.SlavicGod = "Сварожичи";
                        }
                    }
                    else if (monthInFile == 10)
                    {
                        if (dayInFile <= 15)
                        {
                            person.SlavicGod = "Сварожичи";
                        }
                        else
                        {
                            person.SlavicGod = "Морена";
                        }
                    }
                    else if (monthInFile == 11)
                    {
                        if (dayInFile <= 8)
                        {
                            person.SlavicGod = "Морена";
                        }
                        else if (dayInFile <= 28 && dayInFile > 8)
                        {
                            person.SlavicGod = "Зима";
                        }
                        else
                        {
                            person.SlavicGod = "Карачун";
                        }
                    }
                    else
                    {
                        if (dayInFile <= 23)
                        {
                            person.SlavicGod = "Карачун";
                        }
                        else
                        {
                            person.SlavicGod = "Мороз";
                        }
                    }

                    ShowMessage.Text = "Успешно записано в файл";
                    sw.WriteLine(person.Lastname + ";" + person.Name + ";" + person.Patronymic + ";" + person.FM + ";" + person.Number + ";" + person.Day + ";" + person.Month + ";" + person.Year + ";" + dayOfWeek+";"+person.SlavicGod);

                }
            }

        }

                private void Back_Click(object sender, RoutedEventArgs e)
        {
            ShowUsers.IsVisible = false;
            WritePanel.IsVisible = true;
        }
    }
}